import { type DetectedBarcode, type BarcodeFormat } from 'barcode-detector/pure';
export declare const setScanningFormats: (formats: BarcodeFormat[]) => void;
type ScanHandler = (_: DetectedBarcode[]) => void;
/**
 * Continuously extracts frames from camera stream and tries to read
 * potentially pictured QR codes.
 */
export declare const keepScanning: (videoElement: HTMLVideoElement, { detectHandler, locateHandler, minDelay, formats }: {
    detectHandler: ScanHandler;
    locateHandler: ScanHandler;
    minDelay: number;
    formats: BarcodeFormat[];
}) => Promise<void>;
export declare const processFile: (file: File, formats?: BarcodeFormat[]) => Promise<DetectedBarcode[]>;
export declare const processUrl: (url: string, formats?: BarcodeFormat[]) => Promise<DetectedBarcode[]>;
export {};
